;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Screem Drip
;
; PRINT USR DRIP;[Speed],[Step],[CODE "Chr X"]
;
;================================

@Class6=0D92			;Expression evaluator, if value>255 then error B
@StackBC=0BF5			;Move results to BC
@StackA=0C02			;Move results to A
@DFile=400C			;Start of DFile
@LastK=4025			;Key press value
@Seed=4032			;Random Number Seed
@Step=4021			;Spare1, Step value  IY+33
@Fill=407B			;Spare2, Fill value  IY+123
@Speed=407C			;Spare3, Speed value IY+124
@Buff1=403C			;Columns done buffer

@Drip
	LD BC,0018		;Clear PRBuff area
	LD HL,Buff1
	LD (HL),B
	LD D,H
	LD E,L
	INC DE
	LDIR
	LD (IY+33),B		;Set default values
	LD (Fill),BC
	RST 20			;Get next character
	LD A,75			;Test for parameters
	INC A
	CP (HL)
	JR Z Count		;Jump if no value specified
	CALL Class6		;Evaluate [Speed] expression
	RST 20 			;Get next character
	CALL Class6		;Evaluate [Step] expression
	CALL StackBC		;Move results to BC, B=Step, A=C=Speed
@NoPars
	LD (IY+33),B		;Set Step
	LD (Speed),A		;Set Speed
	RST 20 			;Get next character
	CALL Class6		;Evaluate [CODE "Chr X"] expression
	CALL StackA		;Move results to A
	LD (Fill),A		;Set Fill
;================================
; Calculate count value
;================================
@Count
	LD DE,0000		;Initialize counter
	LD BC,0319		;CPI counter, 793
	LD HL,(DFile)		;Get DFile addr
@NextDF
	LD A,(Fill)		;Fill chr
@TestFill
	CPI			;(HL)=Fill?
	JR Z TestFill		;Jump if (HL)=fill
	INC DE			;Increase counter
	LD A,B			;Test CPI counter (JP PO not allowed)
	OR C
	JR NZ NextDF		;Loop until CPI counter=0
	EX DE,HL		;HL=Count
	LD C,19			;Adjust for N/L chrs
	SBC HL,BC
	EX DE,HL		;DE=Count
	JR Start		;"RET"
;================================
; Return random number between 0 and 31
;================================
@RNDNum
	LD DE,(Seed)
	LD H,E 
	LD L,FD 
	LD A,D 
	OR A 
	LD B,00 
	SBC HL,DE 
	SBC A,B 
	SBC HL,DE 
	SBC A,B 
	LD E,A 
	LD D,B 
	SBC HL,DE 
	JR NC +1
	INC HL 
	LD (Seed),HL
	LD A,L
	AND 1F
	LD C,A
	JR RndX+2
;================================
@Loop
;Speed=Speed-Step
	LD A,(Speed)		;Get speed
	AND A			;Test for 0
	JR Z +6			;Jump if 0
	SUB (IY+33)		;Subtract step
	JR NC +1		;Jump if >0
	XOR A			;A=0
	LD (Speed),A		;Set new speed
@Start
	PUSH DE			;PUSH counter
@NextX
	POP DE			;POP counter
	PUSH DE			;PUSH counter
@RndX
	JR RNDNum		;"CALL RNDNum", Xcoord=0 to 31
	LD HL,Buff1		;Test if this column completed
	ADD HL,BC		;Add Xcoord
	BIT 7,(HL)
	JR NZ RndX		;Already done so pick another Xcoord
	LD D,(IY+123)		;D=Fill chr
	LD HL,(DFile)		;Locate column addr
	INC HL
	ADD HL,BC		;Add Xcoord
	LD BC,0021		;Bytes/row
	SBC HL,BC
	LD E,19			;E=Row count
@NextY
	ADD HL,BC		;Next row addr
	DEC E			;Last row?
	JR NZ Not24		;Jump if more to do
	LD HL,Buff1		;Mark as completed
	LD C,A			;C=Xcoord
	ADD HL,BC		;Add Xcoord
	LD (HL),FF		;Mark as done
	JR NextX		;Loop, this column done
@Not24
	LD C,A			;Save Xcoord to C
	LD A,(HL)		;Check for fill chr
	CP D			;Fill chr?
	LD A,C			;A=Xccord
	LD C,21			;C=Bytes/row
	JR Z NextY		;Loop if fill chr.
	LD A,(HL)		;Get drip chr
	LD (HL),D		;Print fill chr
@DripIt
	ADD HL,BC		;Next Row
	LD D,(HL)		;Get underneath chr
	LD (HL),A		;Print drip
	PUSH AF			;PUSH drip chr
;Check for keypress status
	LD A,(LastK)		;Get keyboard status
	CP FF			;Key pressed?
	JR Z NoKey		;Jump if no keypress
@Wait
	LD A,(LastK)		;Get keyboard status
	CP FF			;Key pressed?
	JR NZ Wait		;Jump if keypress
	POP AF			;Clear stack
	LD A,01			;Set keypress flag to 1
	JR SetFlag
@NoKey
	LD B,(IY+124)		;Get delay hi byte
	LD C,01			;Set lo byte
@Delay
	LD A,B
	OR C
	DEC BC
	JR NZ Delay		;Loop until BC=0
	POP AF			;POP drip chr
	LD BC,0021
	LD (HL),D		;Print underneath chr
	DEC E			;Decrease row counter
	JR NZ DripIt		;Loop until E=0
	POP DE			;POP counter
	DEC DE			;Decrease counter
	LD A,D 
	OR E
	JR NZ Loop		;Loop until DE=0
@SetFlag
	LD (Fill),A		;Set keypress flag to 0 or 1
	RST 08			;Return via Error Restart, skipping the PRINT routine
	FF
